package com.example.gcm;

import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Iterator;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;

import com.google.android.gcm.GCMBaseIntentService;

public class GCMIntentService extends GCMBaseIntentService {

	protected GCMIntentService(String senderId) {
		super(senderId);
		Log.d(TAG, "GCMIntentService.init (senderId=" + senderId + ")");
	}

	public GCMIntentService() {
		super(MainActivity.SENDER_IDS);
		Log.d(TAG, "GCMIntentService.init (no param)");
	}
	
	private static String TAG = "gcm_demo";

	@Override
	protected void onRegistered(Context context, String registrationId) {
		Log.d(TAG, "GCMIntentService.onRegistered registrationId=" + registrationId);
		sendRegistrationIdToAppServer(registrationId);
	}
	static void sendRegistrationIdToAppServer (String registrationId) {
	}

	@Override
	protected void onUnregistered(Context context, String registrationId) {
		Log.d(TAG, "GCMIntentService.onUnregistered");
		
	}
	@Override
	protected void onError(Context context, String errorId) {
		Log.d(TAG, "GCMIntentService.onError");
	}

	@Override
	protected void onMessage(Context context, Intent intent) {
		Log.d(TAG, "GCMIntentService.onMessage");
		Bundle messageBundle = intent.getExtras();
		Iterator<String> iterator = messageBundle.keySet().iterator();
		while (iterator.hasNext()) {
			String key = iterator.next();
			Log.d(TAG, key + " = " + messageBundle.getString(key));
		}
		try {
			showNotification(context, 
					URLDecoder.decode(messageBundle.getString("message"), "UTF-8"), 
					URLDecoder.decode(messageBundle.getString("detail"), "UTF-8"));
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
	}

	private static void showNotification(Context context, String message, String detail) {
		int iconId = R.drawable.ic_launcher;
		NotificationManager notificationManager = (NotificationManager)context.getSystemService(Context.NOTIFICATION_SERVICE);
		Notification notification = new Notification(iconId, message, System.currentTimeMillis());
		String title = context.getString(R.string.app_name);
		Intent notificationIntent = new Intent(context, MainActivity.class);
		notificationIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_SINGLE_TOP);
		PendingIntent pIntent = PendingIntent.getActivity(context, 0, notificationIntent, 0);
		notification.setLatestEventInfo(context, message, detail, pIntent);
		notification.flags |= Notification.FLAG_AUTO_CANCEL;
		notificationManager.notify(0, notification);
	}

}