package com.example.gcm;

import com.google.android.gcm.GCMRegistrar;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class MainActivity extends Activity {

	private static String TAG = "gcm_demo";
	
	private Button mButtonRegisterGcm;
	private Button mButtonUnregisterGcm;
	
	public static String SENDER_IDS = "XXXXXXXXX"; //適宜書き換えてください

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		mButtonRegisterGcm = (Button) findViewById(R.id.button_register_gcm);
		mButtonRegisterGcm.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				registerGcm();
			}
		});
		mButtonUnregisterGcm = (Button) findViewById(R.id.button_unregister_gcm);
		mButtonUnregisterGcm.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				unregisterGcm();
			}
		});
		
		GCMRegistrar.checkDevice(this);
		GCMRegistrar.checkManifest(this);
		
		final String registrationId = GCMRegistrar.getRegistrationId(this);
		
		if ("".equals(registrationId)) {
			Log.d(TAG, "MainActivity.onCreate not registered.");
			mButtonRegisterGcm.setEnabled(true);
		} else {
			Log.d(TAG, "MainActivity.onCreate already registered.");
			mButtonUnregisterGcm.setEnabled(true);
		}
	}

	private void registerGcm () {
		Log.d(TAG, "MainActivity.registerGcm");
		GCMRegistrar.register(this, SENDER_IDS);
	}
	
	private void unregisterGcm () {
		Log.d(TAG, "MainActivity.unregisterGcm");
		GCMRegistrar.unregister(this);
	}
}
