package com.example.gcm;

import java.io.IOException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.google.android.gcm.server.*;

@SuppressWarnings("serial")
public class GcmServerDemoServlet extends HttpServlet
{

	public void doGet(HttpServletRequest req, HttpServletResponse res)
			throws IOException {
		res.setContentType("text/plain");
		res.getWriter().println("Hello, GCM Server!");
		String[] registrationIds = req.getParameter("registrationId").split("\n");
		String collapseKey = (req.getParameter("collapseKey"));
		if (null==collapseKey || "".equals(collapseKey))
			collapseKey = new Date().toString();
		
		sendMessage(req.getParameter("message"), req.getParameter("detail"), collapseKey, registrationIds, res);
	}
	
	private static final int TIME_TO_LIVE_IN_SEC = 60 * 60; 
	private static final String API_KEY = "XXXXXXXXXXXXXXXXX";

	private static void sendMessage(String message, String detail,
			String collapseKey, String[] registrationIds, HttpServletResponse res)
			throws IOException {
		Sender sender = new Sender(API_KEY);
		Message gcmMessage = new Message.Builder().collapseKey(collapseKey)
				.timeToLive(TIME_TO_LIVE_IN_SEC)
				.addData("message", URLEncoder.encode(message, "UTF-8"))
				.addData("detail", URLEncoder.encode(detail, "UTF-8"))
				.build();
		
		List<String> targetDevices = new ArrayList<String>();
		for (String registrationId: registrationIds) {
			targetDevices.add(registrationId);
		}
		
		MulticastResult multiResult = sender.send(gcmMessage, targetDevices, 5);
		
		List<Result> results = multiResult.getResults(); 
		for (int i = 0; i < results.size(); i++) {
			Result result = results.get(i);
			res.getWriter().println("Result " + i);
			res.getWriter().println("canonicalRegistrationId = " + result.getCanonicalRegistrationId());
			res.getWriter().println("messageId = " + result.getMessageId());
			res.getWriter().println("errorCodeName()=" + result.getErrorCodeName());
		}
	}
}
