
package jp.asciimw.androidbook.chapter2.andlogo;

import android.app.Activity;
import android.opengl.GLSurfaceView;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import jp.asciimw.androidbook.chapter2.andlogo.core.LogoCommandInvoker;
import jp.asciimw.androidbook.chapter2.andlogo.core.LogoCommandParseException;
import jp.asciimw.androidbook.chapter2.andlogo.gl.LogoRenderer;

public class GlMain extends Activity {
    GLSurfaceView logoView;

    LogoRenderer logoRenderer;

    LogoCommandInvoker mCommandInvoker;

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main_gl);
        logoView = (GLSurfaceView)findViewById(R.id.logoview);
        logoRenderer = new LogoRenderer(this);
        logoView.setRenderer(logoRenderer);

        mCommandInvoker = new LogoCommandInvoker(logoRenderer);
        final TextView text = (TextView)findViewById(R.id.text_command);
        text.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
                doExecute(v.getText().toString());
                return true;
            }
        });

        Button button = (Button)findViewById(R.id.button_run);
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                doExecute(text.getText().toString());
            }
        });

    }

    private void doExecute(String command) {
        if (!TextUtils.isEmpty(command)) {
            try {
                mCommandInvoker.invoke(command);
            } catch (LogoCommandParseException e) {
                Toast.makeText(this, e.getMessage(), Toast.LENGTH_LONG).show();
            }
        }
    }

}
