
package jp.asciimw.androidbook.chapter2.andlogo;

import android.app.Activity;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import jp.asciimw.androidbook.chapter2.andlogo.canvas.LogoView;
import jp.asciimw.androidbook.chapter2.andlogo.core.LogoCommandInvoker;
import jp.asciimw.androidbook.chapter2.andlogo.core.LogoCommandParseException;

public class ViewMain extends Activity {
    LogoView logo;

    LogoCommandInvoker mCommandInvoker;

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main_view);
        logo = (LogoView)findViewById(R.id.logoview);
        mCommandInvoker = new LogoCommandInvoker(logo);
        final TextView text = (TextView)findViewById(R.id.text_command);
        text.setOnEditorActionListener(new TextView.OnEditorActionListener() {

            @Override
            public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
                doExecute(v.getText().toString());
                return true;
            }
        });
        // text.setOnKeyListener(new View.OnKeyListener() {
        // @Override
        // public boolean onKey(View v, int keyCode, KeyEvent event) {
        // if (event.getAction() == KeyEvent.ACTION_DOWN
        // && keyCode == KeyEvent.KEYCODE_ENTER) {
        // String command = text.getText().toString();
        // doExecute(command);
        // return true;
        // }
        // return false;
        // }
        // });

        Button button = (Button)findViewById(R.id.button_run);
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                doExecute(text.getText().toString());
            }
        });

    }

    private void doExecute(String command) {
        if (!TextUtils.isEmpty(command)) {
            try {
                mCommandInvoker.invoke(command);
            } catch (LogoCommandParseException e) {
                Toast.makeText(this, e.getMessage(), Toast.LENGTH_LONG).show();
            }
        }
    }

}
