package jp.asciimw.androidbook.chapter2.service;

import android.app.IntentService;
import android.content.Intent;
import android.os.Handler;
import android.util.Log;
import android.widget.Toast;

public class ToastIntentService extends IntentService {
    private static final String LOG_TAG = ToastIntentService.class.getSimpleName();
    private int member;
    private Handler mHandler;
    private Runnable mToastRunnable = new Runnable() {
        @Override
        public void run() {
            Toast.makeText(ToastIntentService.this, "Object ID:" + ToastIntentService.this.toString() + "\nCount:" + member, Toast.LENGTH_SHORT).show();
        }
    };
    public ToastIntentService() {
        super(ToastIntentService.class.getName());
    }
    public ToastIntentService(String name) {
        super(name);
    }
    @Override
    public void onCreate() {
        super.onCreate();
        Log.d(LOG_TAG, "onCreate");
        mHandler = new Handler();
    }
    @Override
    protected void onHandleIntent(Intent intent) {
        showToast();
    }
    private void showToast() {
        Log.d(LOG_TAG, "Thread ID:" + "[" + Thread.currentThread().getId() + "] ");
        member++;
        mHandler.post(mToastRunnable);
    }
}
