package jp.asciimw.androidbook.chapter2.address;

import android.app.Activity;
import android.database.Cursor;
import android.os.Bundle;
import android.provider.ContactsContract.CommonDataKinds.Phone;
import android.widget.ArrayAdapter;
import android.widget.ListView;

public class AddressListActivity extends Activity {

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        ListView listView = (ListView) findViewById(R.id.listView);
        loadAddressData(listView);
    }

    /**
     * コンタクトリストからデータを取得して、listViewに表示します
     */
    private void loadAddressData(ListView listView) {
        
        // (1) コンテントプロバイダのURIを指定して、カーソルを取得
        Cursor cursor = getContentResolver().query(Phone.CONTENT_URI, null, null, null, null);

        // (2) データを取得したい列名を指定して、列番号を取得
        int contact_id = cursor.getColumnIndexOrThrow(Phone.CONTACT_ID);
        int display_name = cursor.getColumnIndexOrThrow(Phone.DISPLAY_NAME);
        int phone_number = cursor.getColumnIndexOrThrow(Phone.DATA);

        // (3) カーソルから連絡先のデータを取得して、listViewに表示する
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(
                this, android.R.layout.simple_list_item_1);
        while (cursor.moveToNext()) {
            String row = String.format("[%s] %s \n%s",
                    cursor.getString(contact_id),
                    cursor.getString(display_name),
                    cursor.getString(phone_number));
            adapter.add(row);
        }
        listView.setAdapter(adapter);

    }
}