package jp.asciimw.androidbook.chapter2.backup_sample;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.os.Bundle;
import android.widget.TextView;

public class BackupSampleActivity extends Activity {
    
    static String preferencesFileName = "config";
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
    }
    
    @Override
    protected void onResume() {
        super.onResume();
        updateStatus();
    }

    /**
     * プリファレンス内のカウントを増加し、ビューの表示も更新する
     */
    private void updateStatus() {
        
        SharedPreferences preferences 
            = getSharedPreferences(preferencesFileName, Context.MODE_PRIVATE);
        Editor editor = preferences.edit();
        int resumeCount = preferences.getInt("RESUME_COUNT", 0);
        editor.putInt("RESUME_COUNT", resumeCount+1);
        editor.commit();
        
        TextView resumeCountText = (TextView) findViewById(R.id.resumeCount);
        resumeCountText.setText(String.format( "%d", resumeCount));
        
    }

}