package jp.asciimw.androidbook.chapter2.idlemonster;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

public class ImosDbHelper extends SQLiteOpenHelper {

    private static final String DB_NAME = "imos_db";
    private static final int DB_VERSION = 1;

    private static final String CREATE_TABLE_MONSTERS = "CREATE TABLE monsters ( "
            + "id INTEGER PRIMARY KEY, "
            + "name TEXT, "
            + "attack INTEGER NOT NULL, "
            + "defence INTERGER NOT NULL )";
    private static final String CREATE_TABLE_SPECIAL_SKILLS = "CREATE TABLE special_skills ( "
            + "id INTEGER PRIMARY KEY, "
            + "monster_id REFERENCES monsters(_id), "
            + "name TEXT )";

    public ImosDbHelper(Context context) {
        super(context, DB_NAME, null, DB_VERSION);
    }

    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL(CREATE_TABLE_MONSTERS);
        db.execSQL(CREATE_TABLE_SPECIAL_SKILLS);
        loadMasterData(db);
    }

    private void loadMasterData(SQLiteDatabase db) {
        // マスタデータ作成(モンスター)
        String insertMonster = "INSERT INTO monsters(id,name,attack,defence) VALUES (?, ?, ?, ?)";
        db.execSQL(insertMonster, new Object[] { 1, "ねこむすめ", 1000, 600 });
        db.execSQL(insertMonster, new Object[] { 2, "すなかけばばあ", 880, 1360 });
        db.execSQL(insertMonster, new Object[] { 3, "ろくろくび", 2300, 1680 });
        // マスタデータ作成(特技)
        String insertSpecialSkill = "INSERT INTO special_skills(id,monster_id,name) VALUES (?, ?, ?)";
        db.execSQL(insertSpecialSkill, new Object[] { 1, 1, "ひっかき" });
        db.execSQL(insertSpecialSkill, new Object[] { 2, 2, "すなかけ" });
        db.execSQL(insertSpecialSkill, new Object[] { 3, 2, "たつまき" });
        db.execSQL(insertSpecialSkill, new Object[] { 4, 3, "ぬけくび" });
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        db.execSQL("DROP TABLE monsters");
        db.execSQL("DROP TABLE special_skills");
        onCreate(db);
    }

}
