package jp.asciimw.androidbook.chapter2.idlemonster2;

import android.app.Activity;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.widget.ArrayAdapter;
import android.widget.ListView;

public class Imos2Activity extends Activity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        ListView monsterList = (ListView) findViewById(R.id.monster_list);
        loadListData(monsterList, "SELECT id, name FROM monsters");

        ListView specialSkillList = (ListView) findViewById(R.id.special_skill_list);
        loadListData(specialSkillList, "SELECT id, name FROM special_skills");

    }

    private void loadListData(ListView view, String sql) {
        ArrayAdapter<String> simpleAdapter = new ArrayAdapter<String>(
                this, android.R.layout.simple_expandable_list_item_1);
        view.setAdapter(simpleAdapter);
        // ここからデータベース処理
        ImosDbHelper dbHelper = new ImosDbHelper(this);
        SQLiteDatabase db = dbHelper.getReadableDatabase();
        Cursor c = db.rawQuery(sql, null);
        c.moveToFirst();
        for (int i = 0; i < c.getCount(); i++) {
            simpleAdapter.add(c.getString(0) + ":"
                    + c.getString(1));
            c.moveToNext();
        }
        c.close();
        // ここまでデータベース処理
    }

}