package jp.asciimw.androidbook.chapter2.imos_consumer;

import android.net.Uri;
import android.provider.BaseColumns;

/**
 * モンスターの列指定情報
 */
public class Monsters implements BaseColumns {
    
    /** コンテントプロバイダ識別用の情報 */
    public static final String AUTHORITY = "jp.asciimw.androidbook.chapter2.imos_provider";
    /** URI定数 */
    public static final Uri CONTENT_URI = Uri.parse("content://"+AUTHORITY+"/monsters");
    /** CONTENT_URIのMIMEタイプ(モンスター全体) */
    public static final String CONTENT_TYPE = "vnd.android.cursor.dir/vnd.imos.monsters";
    /** CONTENT_URIのMIMEタイプ(個々のモンスター) */
    public static final String CONTENT_ITEM_TYPE = "vnd.android.cursor.item/vnd.imos.monsters";
    
    // 以下、コンテントプロバイダ使用時の列指定。imos_db の monsters テーブルに対応
    
    /** 列名：_ID */
    public static final String _ID = "id"; // BaseColumnsで定義済みのものを上書き("_id"->"id")
    /** 列名：名前 */
    public static final String NAME = "name";
    /** 列名：レア度 */
    public static final String RARITY = "rarity";
    /** 列名：攻撃力 */
    public static final String ATTACK = "attack";
    /** 列名：守備力 */
    public static final String DEFENCE = "defence";

}
