package jp.asciimw.androidbook.chapter2.imos_provider;

import android.app.Activity;
import android.database.Cursor;
import android.os.Bundle;
import android.widget.ArrayAdapter;
import android.widget.ListView;

public class Imos3Activity extends Activity {
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        ListView monsterList = (ListView) findViewById(R.id.monster_list);
        loadMonsterData(monsterList);
    }

    /**
     * モンスターのデータを取得して、listViewに表示します
     */
    private void loadMonsterData(ListView listView) {
        
        // (1) コンテントプロバイダのURIを指定して、カーソルを取得
        Cursor cursor = getContentResolver().query(Monsters.CONTENT_URI, null, null, null, null);

        // (2) データを取得したい列名を指定して、列番号を取得
        int id = cursor.getColumnIndexOrThrow(Monsters._ID);
        int name = cursor.getColumnIndexOrThrow(Monsters.NAME);
        int attack = cursor.getColumnIndexOrThrow(Monsters.ATTACK);
        int deffence = cursor.getColumnIndexOrThrow(Monsters.DEFENCE);

        // (3) カーソルから連絡先のデータを取得して、listViewに表示する
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(
                this, android.R.layout.simple_list_item_1);
        while (cursor.moveToNext()) {
            String row = String.format("[%s] %s \n attack:%s defence:%s",
                    cursor.getString(id),
                    cursor.getString(name),
                    cursor.getString(attack),
                    cursor.getString(deffence));
            adapter.add(row);
        }
        listView.setAdapter(adapter);

    }

}