package jp.asciimw.androidbook.chapter2.preferences;

import java.util.Date;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.os.Bundle;
import android.widget.TextView;
import android.widget.Toast;

public class PreferencesSampleActivity extends Activity {

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        String firstBootTimeText = getFirstBootTimeText();
        TextView firstBootText = (TextView) findViewById(R.id.first_boot);
        firstBootText.setText("FIRST_BOOT: " + firstBootTimeText);
    }

    /**
     * プリファレンスから初回起動日時を文字列形式で取得します。
     */
    private String getFirstBootTimeText() {
        // (1)プリファレンスの宣言
        SharedPreferences preferences = getSharedPreferences("config", Context.MODE_PRIVATE);
        // (2)プリファレンスの取得
        String firstBootTimeText = preferences.getString("FIRST_BOOT", null);
        // (3)プリファレンスからデータが取得できなかった場合、現在日時を保存
        if (firstBootTimeText == null) {
            firstBootTimeText = new Date().toString();
            Editor editor = preferences.edit();
            editor.putString("FIRST_BOOT", firstBootTimeText);
            editor.commit();
            Toast.makeText(this, "初回起動時刻を保存しました", Toast.LENGTH_LONG).show();
        }
        return firstBootTimeText;
    }

}