package jp.asciimw.androidbook.chapter2.address_list2;

import android.app.Activity;
import android.app.LoaderManager;
import android.app.LoaderManager.LoaderCallbacks;
import android.content.CursorLoader;
import android.content.Loader;
import android.database.Cursor;
import android.os.Bundle;
import android.provider.ContactsContract.CommonDataKinds.Phone;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;

public class AddressList2Activity extends Activity implements LoaderCallbacks<Cursor>{
    
    SimpleCursorAdapter adapter;
    private static final int LOADER_ID = 0;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        // Adapterを作成して、listViewにセット (この時点でカーソルはnull)
        adapter = new SimpleCursorAdapter(
                this, R.layout.row, null,
                new String[] { Phone.CONTACT_ID, Phone.DISPLAY_NAME, Phone.DATA },
                new int[] { R.id.contact_id, R.id.display_name, R.id.phone_number }
                );
        ListView listView = (ListView) findViewById(R.id.listView);
        listView.setAdapter(adapter);
        
        LoaderManager manager = getLoaderManager();
        manager.initLoader(LOADER_ID, null, this);
    }

    /* 新規作成時のコールバックメソッド */
    @Override
    public Loader<Cursor> onCreateLoader(int id, Bundle args) {
        // ２つめ以降の引数指定はContentResolver#queryと同様
        return new CursorLoader(this, Phone.CONTENT_URI, null, null, null, null);
    }

    /* 読み込み完了時のコールバックメソッド */
    @Override 
    public void onLoadFinished(Loader<Cursor> loader, Cursor data) {
        adapter.swapCursor(data);
    }

    /* リセット時のコールバックメソッド */
    @Override
    public void onLoaderReset(Loader<Cursor> loader) {
        adapter.swapCursor(null);
    }
    
}