package jp.asciimw.androidbook.chapter2.twitter2;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import android.app.Activity;
import android.os.Bundle;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.Toast;
import android.view.View;

public class Twitter2Activity extends Activity implements View.OnClickListener {
    
    private static final String KEYWORD = "android";
    private List<Map<String,String>> mTweetList;
    private SimpleAdapter mAdapter;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        this.setTitle("Twitter Search: " + KEYWORD);
        mTweetList = new ArrayList<Map<String,String>>();
        mAdapter = new TweetAdapter(getApplicationContext(), mTweetList);
        Button button = (Button) findViewById(R.id.tweet_button);
        button.setOnClickListener(this);
        ListView tweetList = (ListView) findViewById(R.id.tweet_list);
        tweetList.setAdapter(mAdapter);
        tweetList.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                Toast.makeText(getBaseContext(), 
                        mTweetList.get((int) id).get("text"), Toast.LENGTH_SHORT).show();
            }
        });
        loadTweet();
    }
    
    public void onClick(View view) {
        loadTweet();
    }
    
    private void loadTweet() {
        new TweetLoadTask(KEYWORD,mAdapter,mTweetList).execute((Void) null);
    }
    
}
