package jp.asciimw.androidbook.chapter2.twitter3;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import android.app.Activity;
import android.app.LoaderManager;
import android.app.LoaderManager.LoaderCallbacks;
import android.content.Loader;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.Toast;

public class Twitter3Activity extends Activity
        implements LoaderCallbacks<List<Map<String, String>>>, View.OnClickListener {
    
    private static final int LOADER_ID = 0;
    private static final String KEYWORD = "android";
    private List<Map<String,String>> mTweetList;
    private SimpleAdapter mAdapter;
    private TweetLoader mLoader;
            
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        this.setTitle("Twitter Search: " + KEYWORD);
        mTweetList = new ArrayList<Map<String,String>>();
        mAdapter = new TweetAdapter(getApplicationContext(), mTweetList);
        Button button = (Button) findViewById(R.id.tweet_button);
        button.setOnClickListener(this);
        ListView tweetList = (ListView) findViewById(R.id.tweet_list);
        tweetList.setAdapter(mAdapter);
        tweetList.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                Toast.makeText(getBaseContext(), 
                        mTweetList.get((int) id).get("text"), Toast.LENGTH_SHORT).show();
            }
        });
        // [_[gp悤ύX
        LoaderManager manager = getLoaderManager();
        manager.initLoader(LOADER_ID, null, this);
    }

    @Override
    public void onClick(View view) {
        mLoader.forceLoad();
    }

    @Override
    public Loader<List<Map<String, String>>> onCreateLoader(int id, Bundle args) {
        mLoader = new TweetLoader(this, KEYWORD);
        mLoader.forceLoad();
        return mLoader;
    }

    @Override
    public void onLoadFinished(
            Loader<List<Map<String, String>>> loader, List<Map<String, String>> data) {
        mTweetList.clear();
        mTweetList.addAll(data);
        mAdapter.notifyDataSetChanged();
    }

    @Override
    public void onLoaderReset(Loader<List<Map<String, String>>> loader) {
        mTweetList.clear();
        mAdapter.notifyDataSetChanged();
    }
        
}