package jp.asciimw.androidbook.chapter2.resources;

import android.app.Activity;
import android.graphics.drawable.ClipDrawable;
import android.graphics.drawable.LevelListDrawable;
import android.graphics.drawable.TransitionDrawable;
import android.os.Bundle;
import android.view.View;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.ImageView;

public class DrawableActivity extends Activity {
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.drawable_example);
        final ImageView bitmapImageView = (ImageView) findViewById(R.id.bitmap_image);
        final Animation rotate = AnimationUtils.loadAnimation(DrawableActivity.this, R.anim.rotate);
        bitmapImageView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                bitmapImageView.startAnimation(rotate);
            }
        });
        
        final ImageView transitionImageView = (ImageView) findViewById(R.id.transition_image);
        transitionImageView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ((TransitionDrawable)transitionImageView.getDrawable()).startTransition(500);
            }
        });
        final ImageView levelImageView = (ImageView) findViewById(R.id.level_image);
        levelImageView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ((LevelListDrawable)levelImageView.getDrawable()).setLevel(1);
            }
        });
        final ImageView clipImageView = (ImageView) findViewById(R.id.clip_image);
        ((ClipDrawable)clipImageView.getDrawable()).setLevel(5000);
    }
}
