
package jp.asciimw.androidbook.chapter3.scale;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.support.v4.app.NavUtils;
import android.util.DisplayMetrics;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;

import java.io.IOException;

public class MainActivity extends Activity {

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        StringBuilder text = new StringBuilder();
        try {
            DisplayMetrics metrics = new DisplayMetrics();
            getWindowManager().getDefaultDisplay().getMetrics(metrics);
            {
                Bitmap bitmap = BitmapFactory.decodeResource(getResources(), R.drawable.turtle);
                text.append("Resource - width:" + bitmap.getWidth() + ", height:"
                        + bitmap.getHeight() + " \n ");
            }
            {
                Bitmap bitmap = BitmapFactory.decodeStream(getAssets().open("turtle.png"));
                text.append("Assets (default) - width:" + bitmap.getWidth() + ", height:"
                        + bitmap.getHeight() + " \n ");
            }
            {
                BitmapFactory.Options opts = new BitmapFactory.Options();
                opts.inScaled = true;
                opts.inDensity = DisplayMetrics.DENSITY_MEDIUM;
                opts.inTargetDensity = metrics.densityDpi;
                Bitmap bitmap = BitmapFactory.decodeStream(getAssets().open("turtle.png"), null,
                        opts);
                text.append("Assets (load as medium) - width:" + bitmap.getWidth() + ", height:"
                        + bitmap.getHeight());
            }
        } catch (IOException e) {
            ;
        }
        ((TextView)findViewById(R.id.bitmap_text)).setText(text);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case android.R.id.home:
                NavUtils.navigateUpFromSameTask(this);
                return true;
        }
        return super.onOptionsItemSelected(item);
    }

}
