package jp.asciimw.androidbook.chapter3.process.foo;

import android.content.Intent;
import android.os.Parcel;
import android.os.Parcelable;

public class Foo implements Parcelable {

    public static final Creator<Foo> CREATOR = new Creator<Foo>() {

        @Override
        public Foo createFromParcel(Parcel source) {
            return new Foo(source);
        }

        @Override
        public Foo[] newArray(int size) {
            return new Foo[size];
        }

    };

    private int i;
    private String s;
    private Intent intent;

    public Foo(int i, String s, Intent intent) {
        this.i = i;
        this.s = s;
        this.intent = intent;
    }

    public Foo(Parcel source) {
        i = source.readInt();
        s = source.readString();
        intent = source.readParcelable(Intent.class.getClassLoader());
    }

    public int getInt() {
        return i;
    }

    public String getString() {
        return s;
    }

    public Intent getIntent() {
        return intent;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeInt(i);
        dest.writeString(s);
        dest.writeParcelable(intent, flags);
    }

}
