package jp.asciimw.androidbook.chapter3.process.foo;

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.os.RemoteException;
import android.util.Log;

public class FooService extends Service {

    private Foo mFoo;
    private final IFooService.Stub mBinder = new IFooService.Stub() {

        @Override
        public Foo startFooActivity(Foo foo) throws RemoteException {
            return startActivity(foo);
        }

        @Override
        public void setFoo(Foo foo) throws RemoteException {
            set(foo);
        }

        @Override
        public Foo getFoo() throws RemoteException {
            return get();
        }

    };

    @Override
    public IBinder onBind(Intent intent) {
        Log.d(getString(R.string.app_name), "onBind: " + Thread.currentThread());
        mFoo = intent.getParcelableExtra("foo");
        return mBinder;
    }

    private synchronized Foo startActivity(Foo foo) {
        Log.d(getString(R.string.app_name),
                "startActivity: " + Thread.currentThread());
        startActivity(new Intent(this, FooActivity.class).putExtra("foo", foo)
                .setFlags(
                        Intent.FLAG_ACTIVITY_NEW_TASK
                                | Intent.FLAG_ACTIVITY_SINGLE_TOP));
        return mFoo;
    }

    private synchronized void set(Foo foo) {
        Log.d(getString(R.string.app_name), "set: " + Thread.currentThread());
        mFoo = foo;
    }

    private synchronized Foo get() {
        Log.d(getString(R.string.app_name), "get: " + Thread.currentThread());
        return mFoo;
    }

}
