package jp.asciimw.androidbook.chapter3.trianglechecker.model;

import jp.asciimw.androidbook.chapter3.trianglechecker.model.Triangle;
import junit.framework.TestCase;

public class TriangleTest extends TestCase {

    public void test01() {
        Triangle testee = new Triangle(2,3,4);
        assertEquals(Triangle.Type.SCALENCE, testee.checkType());
    }

    public void test02() {
        Triangle testee = new Triangle(1,2,2);
        assertEquals(Triangle.Type.ISOSCELES, testee.checkType());
    }
    
    public void test03() {
        Triangle testee = new Triangle(2,2,2);
        assertEquals(Triangle.Type.REGULAR, testee.checkType());
    }
    
    public void test04() {
        try {
            Triangle testee = new Triangle(-1,2,2);
            fail("Wrong instance: " + testee.checkType().toString());
        } catch (RuntimeException e) {
            assertEquals("３辺の長さは自然数で入力してください",e.getMessage());
        }
    }
    
    public void test05() {
        try {
            Triangle testee = new Triangle(1,2,3);
            fail("Wrong instance: " + testee.checkType().toString());
        } catch (RuntimeException e) {
            assertEquals("どの１辺も、他の２辺の和より長くはなりません",e.getMessage());
        }
    }

}
