package jp.asciimw.androidbook.chapter3.trianglechecker;

import jp.asciimw.androidbook.chapter3.trianglechecker.model.Triangle;
import jp.asciimw.androidbook.chapter3.trianglechecker.R;
import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnFocusChangeListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class TriangleActivity extends Activity implements OnClickListener, OnFocusChangeListener{
    
    private EditText text_a;
    private EditText text_b;
    private EditText text_c;
    private TextView error;
    private TextView result;
    private Button button;

    private Triangle t;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        text_a = (EditText)findViewById(R.id.editText_a);
        text_b = (EditText)findViewById(R.id.editText_b);
        text_c = (EditText)findViewById(R.id.editText_c);
        error  = (TextView)findViewById(R.id.error_message);
        result = (TextView)findViewById(R.id.result_message);
        button = (Button) findViewById(R.id.do_check);
        text_a.setOnFocusChangeListener(this);
        text_b.setOnFocusChangeListener(this);
        text_c.setOnFocusChangeListener(this);
        button.setOnClickListener(this);
    }
    
    @Override
    public void onClick(View v) {
        updateTriangle();
        if (t != null) {
            showMessage(result, t.checkType().name+"です");
        }
    }

    @Override
    public void onFocusChange(View v, boolean hasFocus) {
        updateTriangle();
        hideMessage(result);
    }

    private void updateTriangle() {
        try {
            int a = Integer.parseInt(text_a.getText().toString());
            int b = Integer.parseInt(text_b.getText().toString());
            int c = Integer.parseInt(text_c.getText().toString());
            t = new Triangle(a, b, c);
            hideMessage(error);
            button.setEnabled(true);
        } catch (NumberFormatException e) {
            t = null;
            showMessage( error, "３辺の長さは自然数で入力してください");
            button.setEnabled(false);
        } catch (IllegalArgumentException e) {
            t = null;
            showMessage( error, e.getMessage());
            button.setEnabled(false);
        }
    }
    
    private void showMessage(TextView view, String message) {
        view.setText(message);
        view.setVisibility(View.VISIBLE);
    }
    
    private void hideMessage(TextView view) {
        view.setText("");
        view.setVisibility(View.INVISIBLE);        
    }
    
}