package jp.asciimw.androidbook.chapter3.particularserviceuser;

import jp.asciimw.androidbook.chapter3.particularservice.IParticularService;
import android.app.Activity;
import android.content.ComponentName;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.IBinder;
import android.os.RemoteException;
import android.view.View;

public class ParticularServiceUserActivity extends Activity {
    private IParticularService mParticularService;
    private ServiceConnection mConnection;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
    }
    @Override
    protected void onResume() {
        super.onResume();
        mConnection = new ServiceConnection() {
            public void onServiceConnected(ComponentName className, IBinder service) {
                mParticularService = IParticularService.Stub.asInterface(service);
            }
            public void onServiceDisconnected(ComponentName className) {
                mParticularService = null;
            }
        };
        bindService(new Intent(IParticularService.class.getName()), mConnection, BIND_AUTO_CREATE);
    }

    @Override
    protected void onPause() {
        super.onPause();
        unbindService(mConnection);
    }
    public void click1(View view) {
        try {
            mParticularService.execute1();
        } catch (RemoteException e) {
            throw new RuntimeException(e);
        }
    }
    public void click2(View view) {
        try {
            mParticularService.execute2();
        } catch (RemoteException e) {
            throw new RuntimeException(e);
        }
    }
    public void click5(View view) {
        try {
            mParticularService.execute5();
        } catch (RemoteException e) {
            throw new RuntimeException(e);
        }
    }
}